'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _debounce2 = require('lodash/debounce');

var _debounce3 = _interopRequireDefault(_debounce2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  background-color: ', ';\n  box-shadow: inset 0 0 7px ', ';\n  overflow: hidden;\n  pointer-events: all;\n  position: relative;\n  height: 100%;\n'], ['\n  background-color: ', ';\n  box-shadow: inset 0 0 7px ', ';\n  overflow: hidden;\n  pointer-events: all;\n  position: relative;\n  height: 100%;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _reactResizeAware = require('react-resize-aware');

var _reactResizeAware2 = _interopRequireDefault(_reactResizeAware);

var _polished = require('polished');

var _d3Drag = require('d3-drag');

var _d3Selection = require('d3-selection');

var _reactMotion = require('react-motion');

var _animation = require('../../utils/animation');

var _timeline = require('../../utils/timeline');

var _zooming = require('../../utils/zooming');

var _theme = require('../../theme');

var _theme2 = _interopRequireDefault(_theme);

var _TimelineLoader = require('./_TimelineLoader');

var _TimelineLoader2 = _interopRequireDefault(_TimelineLoader);

var _TimelineDeployments = require('./_TimelineDeployments');

var _TimelineDeployments2 = _interopRequireDefault(_TimelineDeployments);

var _TimelinePeriodLabels = require('./_TimelinePeriodLabels');

var _TimelinePeriodLabels2 = _interopRequireDefault(_TimelinePeriodLabels);

var _TimelineRange = require('./_TimelineRange');

var _TimelineRange2 = _interopRequireDefault(_TimelineRange);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var TIMELINE_HEIGHT = '55px';

var TimelineWrapper = _styledComponents2.default.div.withConfig({
  displayName: '_Timeline__TimelineWrapper'
})(['width:100%;height:', ';&:before,&:after{border:1px solid ', ';background-color:', ';z-index:', ';box-sizing:border-box;content:\'\';pointer-events:none;position:absolute;display:block;left:50%;border-top:0;border-bottom:0;margin-left:-1px;width:3px;}&:before{top:0;height:', ';}&:after{top:', ';height:9px;opacity:0.15;}'], TIMELINE_HEIGHT, function (props) {
  return props.theme.colors.white;
}, function (props) {
  return props.theme.colors.accent.orange;
}, function (props) {
  return props.theme.layers.front;
}, TIMELINE_HEIGHT, TIMELINE_HEIGHT);

// From https://stackoverflow.com/a/18294634
var FullyPannableCanvas = _styledComponents2.default.div.withConfig({
  displayName: '_Timeline__FullyPannableCanvas'
})(['width:100%;height:100%;cursor:move;cursor:grab;cursor:-moz-grab;cursor:-webkit-grab;', ';'], function (props) {
  return props.panning && '\n    cursor: grabbing;\n    cursor: -moz-grabbing;\n    cursor: -webkit-grabbing;\n  ';
});

var TimelineContainer = FullyPannableCanvas.extend(_templateObject, function (props) {
  return (0, _polished.transparentize)(0.15, props.theme.colors.white);
}, function (props) {
  return props.theme.colors.gray;
});

var TimelineCanvas = _styledComponents2.default.div.withConfig({
  displayName: '_Timeline__TimelineCanvas'
})(['transform:translateX(', 'px);position:absolute;height:100%;'], function (props) {
  return props.width / 2;
});

var TimelineAxis = _styledComponents2.default.div.withConfig({
  displayName: '_Timeline__TimelineAxis'
})(['height:100%;']);

var TimelinePeriodLabelsWrapper = _styledComponents2.default.div.withConfig({
  displayName: '_Timeline__TimelinePeriodLabelsWrapper'
})(['transform:translateY(1px);position:absolute;']);

var Timeline = function (_React$PureComponent) {
  _inherits(Timeline, _React$PureComponent);

  function Timeline(props) {
    _classCallCheck(this, Timeline);

    var _this = _possibleConstructorReturn(this, (Timeline.__proto__ || Object.getPrototypeOf(Timeline)).call(this, props));

    _this.handlePanStart = function () {
      _this.setState({ isPanning: true });
    };

    _this.handlePanEnd = function () {
      if (_this.state.hasPanned) {
        _this.props.onRelease();
      }
      _this.setState({ isPanning: false, hasPanned: false });
      _this.delayedUpdateVisibleRange();
    };

    _this.handlePan = function () {
      var timeScale = (0, _timeline.getTimeScale)(_this.props);
      var momentTimestamp = timeScale.invert(-_d3Selection.event.dx);
      _this.props.onPan(momentTimestamp);
      _this.setState({ hasPanned: true });
    };

    _this.handleZoom = function (ev) {
      var durationMsPerPixel = _this.props.durationMsPerPixel;

      _this.props.onZoom(durationMsPerPixel / (0, _zooming.zoomFactor)(ev));
      _this.delayedUpdateVisibleRange();
      ev.preventDefault();
    };

    _this.handleResize = function (_ref) {
      var width = _ref.width;

      // Update the timeline dimension information.
      _this.setState({ width: width });
      _this.delayedUpdateVisibleRange();
      _this.props.onResize(width);
    };

    _this.updateVisibleRange = function () {
      var width = _this.state.width;

      var timeScale = (0, _timeline.getTimeScale)(_this.props);

      // Update the visible part of the timeline.
      _this.props.onUpdateVisibleRange({
        startAt: (0, _moment2.default)(timeScale.invert(-width / 2)).utc().format(),
        endAt: (0, _moment2.default)(timeScale.invert(width / 2)).utc().format()
      });
    };

    _this.saveSvgRef = function (ref) {
      _this.svgRef = ref;
    };

    _this.state = {
      width: 0,
      isPanning: false,
      hasPanned: false
    };

    _this.delayedHandleResize = (0, _debounce3.default)(_this.handleResize, 200);
    _this.delayedUpdateVisibleRange = (0, _debounce3.default)(_this.updateVisibleRange, 200);
    return _this;
  }

  _createClass(Timeline, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.svg = (0, _d3Selection.select)(this.svgRef);
      this.drag = (0, _d3Drag.drag)().on('start', this.handlePanStart).on('end', this.handlePanEnd).on('drag', this.handlePan);
      this.svg.call(this.drag);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.rangeMs !== nextProps.rangeMs) {
        this.delayedUpdateVisibleRange();
      }
    }
  }, {
    key: 'renderAxis',
    value: function renderAxis(transform) {
      var _this2 = this;

      var width = this.state.width;
      var focusedTimestamp = transform.focusedTimestamp,
          rangeMs = transform.rangeMs;

      var startTimestamp = (0, _moment2.default)(focusedTimestamp).subtract(rangeMs).format();
      var timeScale = (0, _timeline.getTimeScale)(transform);

      return _react2.default.createElement(
        TimelineAxis,
        null,
        _react2.default.createElement(_TimelineRange2.default, {
          color: _theme2.default.colors.gray,
          endAt: this.props.earliestTimestamp,
          timeScale: timeScale,
          width: width
        }),
        _react2.default.createElement(_TimelineRange2.default, {
          color: _theme2.default.colors.gray,
          startAt: this.props.timestampNow,
          timeScale: timeScale,
          width: width
        }),
        this.props.inspectingInterval && _react2.default.createElement(_TimelineRange2.default, {
          color: _theme2.default.colors.accent.blue,
          startAt: startTimestamp,
          endAt: focusedTimestamp,
          timeScale: timeScale,
          width: width
        }),
        _react2.default.createElement(_TimelineDeployments2.default, {
          deployments: this.props.deployments,
          timeScale: timeScale,
          width: width
        }),
        _react2.default.createElement(
          TimelinePeriodLabelsWrapper,
          null,
          ['year', 'month', 'day', 'minute'].map(function (period) {
            return _react2.default.createElement(_TimelinePeriodLabels2.default, _extends({
              key: period,
              period: period,
              width: width,
              onClick: _this2.props.onJump,
              clickableStartAt: _this2.props.earliestTimestamp,
              clickableEndAt: _this2.props.timestampNow
            }, transform));
          })
        ),
        this.props.isLoading && _react2.default.createElement(_TimelineLoader2.default, {
          startAt: this.props.earliestTimestamp,
          endAt: this.props.timestampNow,
          timeScale: timeScale,
          width: width
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _state = this.state,
          isPanning = _state.isPanning,
          width = _state.width;
      var _props = this.props,
          focusedTimestamp = _props.focusedTimestamp,
          durationMsPerPixel = _props.durationMsPerPixel,
          rangeMs = _props.rangeMs;


      return _react2.default.createElement(
        TimelineWrapper,
        null,
        _react2.default.createElement(
          _reactResizeAware2.default,
          {
            onlyEvent: true,
            onResize: this.delayedHandleResize,
            style: { width: '100%', height: '100%' }
          },
          _react2.default.createElement(
            TimelineContainer,
            {
              panning: isPanning,
              innerRef: this.saveSvgRef,
              onWheel: this.handleZoom,
              title: 'Scroll to zoom, drag to pan'
            },
            _react2.default.createElement(
              TimelineCanvas,
              { width: width },
              _react2.default.createElement(
                _reactMotion.Motion,
                {
                  style: {
                    focusedTimestampMs: (0, _animation.strongSpring)((0, _moment2.default)(focusedTimestamp).valueOf()),
                    durationMsPerPixel: (0, _animation.strongSpring)(durationMsPerPixel),
                    rangeMs: (0, _animation.strongSpring)(rangeMs)
                  }
                },
                function (interpolated) {
                  return _this3.renderAxis({
                    focusedTimestamp: (0, _timeline.formattedTimestamp)(interpolated.focusedTimestampMs),
                    durationMsPerPixel: interpolated.durationMsPerPixel,
                    rangeMs: interpolated.rangeMs
                  });
                }
              )
            )
          )
        )
      );
    }
  }]);

  return Timeline;
}(_react2.default.PureComponent);

Timeline.propTypes = {
  inspectingInterval: _propTypes2.default.bool.isRequired,
  timestampNow: _propTypes2.default.string.isRequired,
  focusedTimestamp: _propTypes2.default.string.isRequired,
  earliestTimestamp: _propTypes2.default.string,
  durationMsPerPixel: _propTypes2.default.number.isRequired,
  rangeMs: _propTypes2.default.number.isRequired,
  deployments: _propTypes2.default.array.isRequired,
  isLoading: _propTypes2.default.bool.isRequired,
  onUpdateVisibleRange: _propTypes2.default.func.isRequired,
  onJump: _propTypes2.default.func.isRequired,
  onZoom: _propTypes2.default.func.isRequired,
  onPan: _propTypes2.default.func.isRequired,
  onRelease: _propTypes2.default.func.isRequired,
  onResize: _propTypes2.default.func.isRequired
};

exports.default = Timeline;