'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

var MAX_VISIBLE_RANGE_SECS = _moment2.default.duration(2, 'weeks').asSeconds();

// TODO: A lot of the code here has been taken/modified from PrometheusGraph code.
// Abstract the common code.

var DeploymentAnnotations = _styledComponents2.default.div.withConfig({
  displayName: '_TimelineDeployments__DeploymentAnnotations'
})(['']);

var DeploymentAnnotation = _styledComponents2.default.span.attrs({
  style: function style(_ref) {
    var x = _ref.x;
    return { transform: 'translateX(' + x + 'px)' };
  }
}).withConfig({
  displayName: '_TimelineDeployments__DeploymentAnnotation'
})(['position:absolute;height:100%;top:0;']);

var VerticalLine = _styledComponents2.default.span.withConfig({
  displayName: '_TimelineDeployments__VerticalLine'
})(['border-left:1px solid ', ';pointer-events:none;position:absolute;opacity:0.5;height:100%;'], function (props) {
  return props.theme.colors.accent.blue;
});

var FocusPoint = _styledComponents2.default.span.withConfig({
  displayName: '_TimelineDeployments__FocusPoint'
})(['bottom:0;left:', 'px;width:', 'px;height:', 'px;background-color:', ';border:2px solid ', ';border-radius:', ';position:absolute;cursor:default;'], function (props) {
  return -props.radius - 2;
}, function (props) {
  return 2 * props.radius;
}, function (props) {
  return 2 * props.radius;
}, function (props) {
  return props.theme.colors.white;
}, function (props) {
  return props.theme.colors.accent.blue;
}, function (props) {
  return props.theme.borderRadius.circle;
});

var formattedDeployments = function formattedDeployments(_ref2) {
  var deployments = _ref2.deployments,
      timeScale = _ref2.timeScale,
      width = _ref2.width;
  return deployments.map(function (_ref3) {
    var Data = _ref3.Data,
        Stamp = _ref3.Stamp;

    var _Data$split = Data.split(', '),
        _Data$split2 = _toArray(_Data$split),
        action = _Data$split2[0],
        serviceIDs = _Data$split2.slice(1);

    return {
      key: Data + ' --- ' + Stamp,
      position: timeScale((0, _moment2.default)(Stamp)),
      timestamp: (0, _moment2.default)(Stamp).format(),
      serviceIDs: serviceIDs,
      action: action
    };
  }).filter(function (_ref4) {
    var position = _ref4.position;
    return (
      // Filter out all the deployments that fall out of the timeline.
      -width / 2 <= position && position <= width / 2
    );
  });
};

var TimelineDeployments = function (_React$PureComponent) {
  _inherits(TimelineDeployments, _React$PureComponent);

  function TimelineDeployments(props) {
    _classCallCheck(this, TimelineDeployments);

    var _this = _possibleConstructorReturn(this, (TimelineDeployments.__proto__ || Object.getPrototypeOf(TimelineDeployments)).call(this, props));

    _this.state = {
      deployments: formattedDeployments(props)
    };
    return _this;
  }

  _createClass(TimelineDeployments, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({ deployments: formattedDeployments(nextProps) });
    }
  }, {
    key: 'render',
    value: function render() {
      var timeScale = this.props.timeScale;

      var _timeScale$domain = timeScale.domain(),
          _timeScale$domain2 = _slicedToArray(_timeScale$domain, 2),
          startTimeSec = _timeScale$domain2[0],
          endTimeSec = _timeScale$domain2[1];

      if (!startTimeSec || !endTimeSec) return null;

      // Don't show deployment annotations if we've zoomed out too much.
      // See https://github.com/weaveworks/service-ui/issues/1858.
      if (endTimeSec - startTimeSec > MAX_VISIBLE_RANGE_SECS) return null;

      return _react2.default.createElement(
        DeploymentAnnotations,
        null,
        this.state.deployments.map(function (deployment) {
          return _react2.default.createElement(
            DeploymentAnnotation,
            {
              key: deployment.key,
              x: deployment.position,
              title: deployment.action
            },
            _react2.default.createElement(VerticalLine, null),
            _react2.default.createElement(FocusPoint, { radius: '2' })
          );
        })
      );
    }
  }]);

  return TimelineDeployments;
}(_react2.default.PureComponent);

TimelineDeployments.propTypes = {
  width: _propTypes2.default.number.isRequired,
  timeScale: _propTypes2.default.func.isRequired,
  deployments: _propTypes2.default.array.isRequired
};

exports.default = TimelineDeployments;